﻿using System;
using System.Threading;
using System.Windows;
using WpfAppControl;

namespace TestWpfAppControl
{
    /// <summary>
    /// Interaction logic for App.xaml
    /// </summary>
    public partial class App : Application
    {
        private const int _portNo = 5194;
        private Thread _socketThread = null;

        public static SocketChatClient SocketChat { set; get; }

        private void Application_Startup(object sender, StartupEventArgs e)
        {
            //Process[] ps = Process.GetProcesses();
            //foreach (Process p in ps)
            //{
            //    if (p.ProcessName == TestWpfAppControl.Properties.Resources.UnityExe)
            //    {
            //        p.Kill();
            //    }
            //}

            //_socketThread = new Thread(StartSocketServer);
            //_socketThread.Start();
        }

        private void StartSocketServer()
        {
            // 循环接受客户端的连接请求
            while (SocketChat == null)
            {
                Thread.Sleep(200);
                SocketChat = new SocketChatClient("127.0.0.1", _portNo);
                SocketChat.SocketMessageHandler += new EventHandler<SocketMessageEventArgs>(GetMessageHandler);
            }
        }

        private void GetMessageHandler(object sender, SocketMessageEventArgs e)
        {
            MessageBox.Show(e.Message);
        }

        private void Application_Exit(object sender, ExitEventArgs e)
        {
            if(SocketChat!=null)
            {
                try
                {
                    SocketChat.Stop();
                }
                catch (Exception ex)
                {
                    System.Diagnostics.Debug.WriteLine(ex.Message);
                }
            }
            if(_socketThread!=null)
            {
                try
                {
                    _socketThread.Abort();
                }
                catch (Exception ex)
                {
                    System.Diagnostics.Debug.WriteLine(ex.Message);
                }
            }
            Environment.Exit(0);
        }
    }
}